<template lang="pug">
.pt-5.ma-5
    //- tabFilter(@tabAll="filterAll")
    v-card
      v-tabs(v-model='tab' background-color='green darken-4' centered icons-and-text)
        v-tabs-slider
        v-tab(v-for="(itemTab, index) in tabs" :key="itemTab.name" :href="'#tab-' + (index+1) " @click="filterData(itemTab.value)") {{ itemTab.name }}
          v-icon( :color='itemTab.color') {{ itemTab.icon }}
        v-tabs-items(v-model="tab")
          v-tab-item(v-for="i in 4" :key="i" :value="'tab-' + i")
            v-card
              modalMachine(ref="WashingModal" @save="addInformation" @edit="editInformation")
              h2.pa-2.mr-auto Washing Machine
              v-btn.pa-2.mr-2(color='purple accent-3' @click="showModalWashingMachine()")
                v-icon mdi-plus
              v-row(no-gutters)
                v-col(v-for="(machine, index) in machinesDisplay" :key="index" :cols="3")
                  washingMachineCard(:data="machine" @remove="deleteInformation" @edit="showEditDialog" @start="startTime" @end="resetStatus"
                  @finish="finishStatus")
</template>

<script>
export default {
  name: 'HomePage',
  components: {},
  layout: 'default',
  data () {
    return {
      tabs: [
        { name: 'All', value: 0, icon: 'mdi-heart', color: 'red darken-4' },
        { name: 'Available', value: 1, icon: 'mdi-heart', color: 'yellow darken-4' },
        { name: 'Unavailable', value: 2, icon: 'mdi-heart', color: 'orange darken-4' },
        { name: 'Finish', value: 3, icon: 'mdi-heart', color: 'purple darken-4' }
      ],
      tab: null,
      statusList: [
        { id: 1, statusName: 'available' },
        { id: 2, statusName: 'unavailable' },
        { id: 3, statusName: 'finish' }
      ],
      words: ['A', 'A', 'B', 'B', 'C', 'C'],
      machines: [],
      machinesDisplay: [],
      form: {
        name: '',
        color: ''
      },
      rules: {
        required: value => !!value || 'Required.'
      }
    }
  },
  computed: {},
  created () {},
  mounted () {
    this.machines = [
      { id: 1, name: 'Machine 1', color: 'red', status: this.statusList[0] },
      { id: 2, name: 'Machine 2', color: 'blue', status: this.statusList[1] },
      { id: 3, name: 'Machine 3', color: 'green', status: this.statusList[2] },
      { id: 4, name: 'Machine 4', color: 'yellow', status: this.statusList[0] },
      { id: 5, name: 'Machine 5', color: 'orange', status: this.statusList[0] }
    ]
    this.machinesDisplay = this.machines
  },
  methods: {
    showModalWashingMachine () {
      this.$refs.WashingModal.dialog = true
    },
    addInformation (item) {
      this.machines.push({
        id: this.machines.length ? this.machines[this.machines.length - 1].id + 1 : 1,
        status: this.statusList[0],
        ...item
      })
      this.dialog = false
    },
    editInformation (item) {
      if (item.name && item.color) {
        const findId = this.machines.findIndex(e => e.id === item.id)
        this.machines.splice(findId, 1, { ...item })
      }
    },
    deleteInformation (data) {
      const findIndex = this.machines.findIndex(e => e.id === data.id)
      this.machines.splice(findIndex, 1)
    },
    showEditDialog (data) {
      const getData = this.machines.find(e => e.id === data.id)
      this.$refs.WashingModal.show(getData)
    },
    startTime (data) {
      const getId = this.machines.findIndex(e => e.id === data.id)
      this.machines.splice(getId, 1, { ...data, status: this.statusList[1] })
      // this.machines[getId] = { ...data, status: 'Halo' }
      // console.log(this.machines[getId])
    },
    resetStatus (data) {
      const getId = this.machines.findIndex(e => e.id === data.id)
      this.machines.splice(getId, 1, { ...data, status: this.statusList[0] })
    },
    finishStatus ({ time, data }) {
      if (time === 0) {
        const getId = this.machines.findIndex(e => e.id === data.id)
        this.machines.splice(getId, 1, { ...data, status: this.statusList[2] })
      }
    },
    // filterAll (resultAll) {
    //   console.log(resultAll)
    // },
    filterData (value) {
      if (value === 0) {
        this.machinesDisplay = this.machines
      } else {
        this.machinesDisplay = this.machines.filter((machine) => {
          return machine.status.id === value
        })
      }
      console.log('FilterData', value)
    }
  }
}
</script>
